searchNodes=[{"ref":"EctoJob.Config.html","title":"EctoJob.Config","type":"module","doc":"EctoJob Configuration struct. Configuration may be provided directly to your JobQueue supervisor: supervisor(MyApp.JobQueue, [[repo: MyApp.Repo, max_demand: 100, log_level: :debug]]) Or if the configuration should be environment-specific, use Mix config: config :ecto_job, repo: MyApp.Repo, max_demand: 100, log_level: :debug Otherwise default values will be used. Configurable values: repo: (Required) The Ecto.Repo module in your application to use for accessing the JobQueue max_demand: (Default 100) The number of concurrent worker processes to use, see ConsumerSupervisor for more details log: (Default true) Enables logging using the standard Elixir Logger module log_level: (Default :info) The level used to log messages, see Logger poll_interval: (Default 60_000) Time in milliseconds between polling the JobQueue for scheduled jobs or jobs due to be retried reservation_timeout: (Default 60_000) Time in ms during which a RESERVED job state is held while waiting for a worker to start the job. Subsequent polls will return the job to the AVAILABLE state for retry. execution_timeout: (Default 300_000) Time in ms that a worker is allotted to hold a job in the IN_PROGRESS state before subsequent polls return a job to the AVAILABLE state for retry. The timeout is extended by execution_timeout for every retry attempt until max_attemps is reached for a given job. retry_timeout: (Default 30_000) Time in ms that a job will stay in the RETRY state before subsequent polls return a job to the AVAILABLE state for retry. The timeout is extended by retry_timeout for every retry attempt until max_attemps is reached for a given job. notifications_listen_timeout: (Default 5_000) Time in milliseconds that Notifications.listen!/3 is alloted to start listening to notifications from postgrex for new jobs"},{"ref":"EctoJob.Config.html#new/1","title":"EctoJob.Config.new/1","type":"function","doc":"Constructs a new Config from params, falling back to Application environment then to default values. Example iex&gt; EctoJob.Config.new(repo: MyApp.Repo, log: false) %EctoJob.Config{ repo: MyApp.Repo, max_demand: 100, log: false, log_level: :info, poll_interval: 60_000, reservation_timeout: 60_000, retry_timeout: 30_000, execution_timeout: 300_000, notifications_listen_timeout: 5_000 }"},{"ref":"EctoJob.Config.html#t:t/0","title":"EctoJob.Config.t/0","type":"type","doc":""},{"ref":"EctoJob.JobQueue.html","title":"EctoJob.JobQueue","type":"behaviour","doc":"Mixin for defining an Ecto schema for a Job Queue table in the database. Options :table_name - (required) The name of the job table in the database. :schema_prefix - (optional) The schema prefix for the table. :timestamps_opts - (optional) Configures the timestamp fields for the schema (See Ecto.Schema.timestamps/1) Example defmodule MyApp.JobQueue do use EctoJob.JobQueue, table_name: &quot;jobs&quot;, schema_prefix: &quot;my_app&quot; @spec perform(Ecto.Multi.t(), map()) :: any() def perform(multi, job = %{}) do ... end end"},{"ref":"EctoJob.JobQueue.html#activate_expired_jobs/3","title":"EctoJob.JobQueue.activate_expired_jobs/3","type":"function","doc":"Updates all jobs in the &quot;RESERVED&quot; or &quot;IN_PROGRESS&quot; state with expires time &lt;= now to &quot;AVAILABLE&quot; state. Returns the number of jobs updated."},{"ref":"EctoJob.JobQueue.html#activate_scheduled_jobs/3","title":"EctoJob.JobQueue.activate_scheduled_jobs/3","type":"function","doc":"Updates all jobs in the &quot;SCHEDULED&quot; and &quot;RETRY&quot; state with scheduled time &lt;= now to &quot;AVAILABLE&quot; state. Returns the number of jobs updated."},{"ref":"EctoJob.JobQueue.html#available_jobs/2","title":"EctoJob.JobQueue.available_jobs/2","type":"function","doc":"Builds a query for a batch of available jobs. The batch size is determined by demand"},{"ref":"EctoJob.JobQueue.html#delete_job_changeset/1","title":"EctoJob.JobQueue.delete_job_changeset/1","type":"function","doc":"Creates an Ecto.Changeset that will delete a job, confirming that the attempt counter hasn&#39;t been increased by another worker process."},{"ref":"EctoJob.JobQueue.html#fail_expired_jobs_at_max_attempts/3","title":"EctoJob.JobQueue.fail_expired_jobs_at_max_attempts/3","type":"function","doc":"Updates all jobs that have been attempted the maximum number of times to &quot;FAILED&quot;. Returns the number of jobs updated."},{"ref":"EctoJob.JobQueue.html#increase_time/3","title":"EctoJob.JobQueue.increase_time/3","type":"function","doc":"Computes the expiry time for an &quot;IN_PROGRESS&quot; and schedule time of &quot;RETRY&quot; jobs based on the current time and attempt counter."},{"ref":"EctoJob.JobQueue.html#initial_multi/1","title":"EctoJob.JobQueue.initial_multi/1","type":"function","doc":"Creates an Ecto.Multi struct with the command to delete the given job from the queue. This will be passed as the first argument to the user supplied callback function."},{"ref":"EctoJob.JobQueue.html#job_failed/4","title":"EctoJob.JobQueue.job_failed/4","type":"function","doc":"Transitions a job from &quot;IN_PROGRESS&quot; to &quot;RETRY&quot; or &quot;FAILED&quot; after execution failure. If the job has exceeded the configuredmax_attemptsthe state will move to &quot;FAILED&quot;, otherwise the state is transitioned to&quot;RETRY&quot;` and changes the schedule time so the job will be picked up again."},{"ref":"EctoJob.JobQueue.html#c:perform/2","title":"EctoJob.JobQueue.perform/2","type":"callback","doc":"Job execution callback to be implemented by each JobQueue module. The return type is the same as Ecto.Repo.transaction/1. Example @impl true def perform(multi, params = %{&quot;type&quot; =&gt; &quot;new_user&quot;}), do: NewUser.perform(multi, params) def perform(multi, params = %{&quot;type&quot; =&gt; &quot;sync_crm&quot;}), do: SyncCRM.perform(multi, params)"},{"ref":"EctoJob.JobQueue.html#reservation_expiry/2","title":"EctoJob.JobQueue.reservation_expiry/2","type":"function","doc":"Computes the expiry time for a job reservation to be held, given the current time."},{"ref":"EctoJob.JobQueue.html#reserve_available_jobs/5","title":"EctoJob.JobQueue.reserve_available_jobs/5","type":"function","doc":"Updates a batch of jobs in &quot;AVAILABLE&quot; state to &quot;RESERVED&quot; state with a timeout. The batch size is determined by demand. returns {count, updated_jobs} tuple."},{"ref":"EctoJob.JobQueue.html#update_job_in_progress/4","title":"EctoJob.JobQueue.update_job_in_progress/4","type":"function","doc":"Transitions a job from &quot;RESERVED&quot; to &quot;IN_PROGRESS&quot;. Confirms that the job reservation hasn&#39;t expired by checking: The attempt counter hasn&#39;t been changed The state is still &quot;RESERVED&quot; The expiry time is in the future Updates the state to &quot;IN_PROGRESS&quot;, increments the attempt counter, and sets a timeout proportional to the attempt counter and the expiry_timeout, which defaults to 300_000 ms (5 minutes) unless otherwise configured. Returns {:ok, job} when sucessful, {:error, :expired} otherwise."},{"ref":"EctoJob.JobQueue.html#t:job/0","title":"EctoJob.JobQueue.job/0","type":"type","doc":"A job Ecto.Schema struct."},{"ref":"EctoJob.JobQueue.html#t:repo/0","title":"EctoJob.JobQueue.repo/0","type":"type","doc":"An Ecto.Repo module name"},{"ref":"EctoJob.JobQueue.html#t:schema/0","title":"EctoJob.JobQueue.schema/0","type":"type","doc":"An Ecto.Schema module name"},{"ref":"EctoJob.JobQueue.html#t:state/0","title":"EctoJob.JobQueue.state/0","type":"type","doc":"Job State enumeration &quot;SCHEDULED&quot;: The job is scheduled to run at a future time &quot;AVAILABLE&quot;: The job is availble to be run by the next available worker &quot;RESERVED&quot;: The job has been reserved by a worker for execution &quot;IN_PROGRESS&quot;: The job is currently being worked &quot;RETRY&quot;: The job has failed and it&#39;s waiting for a retry &quot;FAILED&quot;: The job has exceeded the max_attempts and will not be retried again"},{"ref":"EctoJob.Migrations.CreateJobTable.html","title":"EctoJob.Migrations.CreateJobTable","type":"module","doc":"Defines a migration to create a table to be used as a job queue. This migration can be run multiple times with different values to create multiple queues."},{"ref":"EctoJob.Migrations.CreateJobTable.html#down/2","title":"EctoJob.Migrations.CreateJobTable.down/2","type":"function","doc":"Drops the job queue table with the given name, and associated trigger Options :prefix - the prefix (aka Postgresql schema) containing the table to remove."},{"ref":"EctoJob.Migrations.CreateJobTable.html#up/2","title":"EctoJob.Migrations.CreateJobTable.up/2","type":"function","doc":"Adds a job queue table with the given name, and attaches an insert trigger. Options :prefix - the prefix (aka Postgresql schema) to create the table in. :version - the major version of the EctoJob library used to generate the table :timestamps - A keyword list of options passed to the Ecto.Migration.timestamps/1 function."},{"ref":"EctoJob.Migrations.Install.html","title":"EctoJob.Migrations.Install","type":"module","doc":"Defines migrations for installing shared functions"},{"ref":"EctoJob.Migrations.Install.html#down/1","title":"EctoJob.Migrations.Install.down/1","type":"function","doc":"Drops the fn_notify_inserted trigger function Options :prefix - the prefix (aka Postgresql schema) containing the function to remove."},{"ref":"EctoJob.Migrations.Install.html#up/1","title":"EctoJob.Migrations.Install.up/1","type":"function","doc":"Creates the fn_notify_inserted trigger function. This function will be called from triggers attached to job queue tables. Options :prefix - the prefix (aka Postgresql schema) to create the functions in."},{"ref":"EctoJob.Migrations.UpdateJobTable.html","title":"EctoJob.Migrations.UpdateJobTable","type":"module","doc":"Defines an update migration to an especific version of Ecto Job. This migration can be run multiple times with different values to update multiple queues."},{"ref":"EctoJob.Migrations.UpdateJobTable.html#down/2","title":"EctoJob.Migrations.UpdateJobTable.down/2","type":"function","doc":"Rollback updates from job queue table with the given ecto job version and name."},{"ref":"EctoJob.Migrations.UpdateJobTable.html#up/2","title":"EctoJob.Migrations.UpdateJobTable.up/2","type":"function","doc":"Upgrade the job queue table with the given ecto job version and name."},{"ref":"EctoJob.Producer.html","title":"EctoJob.Producer","type":"module","doc":"GenStage producer responsible for reserving available jobs from a job queue, and passing them on to the consumer module. The GenStage will buffer demand when there are insufficient jobs available in the database. Installs a timer to check for expired jobs, and uses a Postgrex.Notifications listener to dispatch jobs immediately when new jobs are inserted into the database and there is pending demand."},{"ref":"EctoJob.Producer.html#handle_demand/2","title":"EctoJob.Producer.handle_demand/2","type":"function","doc":"Dispatch jobs according to the new demand plus any buffered demand."},{"ref":"EctoJob.Producer.html#handle_info/2","title":"EctoJob.Producer.handle_info/2","type":"function","doc":"Messages from the timer and the notifications listener will be handled in handle_info. :poll messages will attempt to activate jobs, and dispatch them according to current demand. :notification messages will dispatch any active jobs according to current demand."},{"ref":"EctoJob.Producer.html#init/1","title":"EctoJob.Producer.init/1","type":"function","doc":"Starts the sweeper timer to activate scheduled/expired jobs and starts listening for new job notifications."},{"ref":"EctoJob.Producer.html#start_link/1","title":"EctoJob.Producer.start_link/1","type":"function","doc":"Starts the producer GenStage process. name : The process name to register this GenStage as repo : The Ecto Repo module to user for querying schema : The EctoJob.JobQueue module to query notifier : The name of the Postgrex.Notifications notifier process poll_interval : Timer interval for activating scheduled/expired jobs notifications_listen_timeout: Time in milliseconds that Notifications.listen!/3 is alloted to start listening to notifications from postgrex for new jobs"},{"ref":"EctoJob.Producer.html#t:notifier/0","title":"EctoJob.Producer.notifier/0","type":"type","doc":""},{"ref":"EctoJob.Producer.html#t:repo/0","title":"EctoJob.Producer.repo/0","type":"type","doc":""},{"ref":"EctoJob.Producer.html#t:schema/0","title":"EctoJob.Producer.schema/0","type":"type","doc":""},{"ref":"EctoJob.Producer.html#t:timeout_ms/0","title":"EctoJob.Producer.timeout_ms/0","type":"type","doc":""},{"ref":"EctoJob.Producer.State.html","title":"EctoJob.Producer.State","type":"module","doc":"Internal state of the Producer GenStage"},{"ref":"EctoJob.Producer.State.html#t:t/0","title":"EctoJob.Producer.State.t/0","type":"type","doc":""},{"ref":"EctoJob.Supervisor.html","title":"EctoJob.Supervisor","type":"module","doc":"Job Queue supervisor that can be started with client applications. The EctoJob.Supervisor will start the required processes to listen for postgres job notifications, GenStage producer and ConsumerSupervisor to process the jobs. Example: def start(_type, _args) do import Supervisor.Spec children = [ supervisor(MyApp.Repo, []), supervisor(MyApp.Endpoint, []), supervisor(EctoJob.Supervisor, [[ name: MyAppJobQueue, app: :my_app, repo: MyApp.Repo, schema: MyApp.JobQueue, max_demand: 100]]) ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) end"},{"ref":"EctoJob.Supervisor.html#start_link/1","title":"EctoJob.Supervisor.start_link/1","type":"function","doc":"Starts an EctoJob queue supervisor"},{"ref":"EctoJob.Worker.html","title":"EctoJob.Worker","type":"module","doc":"Worker module responsible for executing a single Job"},{"ref":"EctoJob.Worker.html#start_link/2","title":"EctoJob.Worker.start_link/2","type":"function","doc":"Equivalent to start_link(config, job, DateTime.utc_now())"},{"ref":"EctoJob.Worker.html#start_link/3","title":"EctoJob.Worker.start_link/3","type":"function","doc":"Start a worker process given a repo module and a job struct This may fail if the job reservation has expired, in which case the job will be reactivated by the producer."},{"ref":"EctoJob.Worker.html#t:repo/0","title":"EctoJob.Worker.repo/0","type":"type","doc":""},{"ref":"EctoJob.WorkerSupervisor.html","title":"EctoJob.WorkerSupervisor","type":"module","doc":"GenStage ConsumerSupervisor that will spawn EctoJob.Worker tasks for jobs."},{"ref":"EctoJob.WorkerSupervisor.html#start_link/1","title":"EctoJob.WorkerSupervisor.start_link/1","type":"function","doc":"Starts the ConsumerSupervisor config : The JobQueue configuration, used for Repo, Logging options subscribe_opts : Should contain [{producer_name, max_demand: max_demand}]"},{"ref":"readme.html","title":"EctoJob","type":"extras","doc":"EctoJob A transactional job queue built with Ecto, PostgreSQL and GenStage"},{"ref":"readme.html#goals","title":"EctoJob - Goals","type":"extras","doc":"Transactional job processing Retries Scheduled jobs Multiple queues Low latency concurrent processing Avoid frequent database polling Library of functions, not a full OTP application"},{"ref":"readme.html#getting-started","title":"EctoJob - Getting Started","type":"extras","doc":"Add :ecto_job to your dependencies {:ecto_job, &quot;~&gt; 3.0&quot;}"},{"ref":"readme.html#installation","title":"EctoJob - Installation","type":"extras","doc":"Add a migration to install the notification function and create the a job queue table: mix ecto.gen.migration create_job_queue defmodule MyApp.Repo.Migrations.CreateJobQueue do use Ecto.Migration @ecto_job_version 3 def up do EctoJob.Migrations.Install.up() EctoJob.Migrations.CreateJobTable.up(&quot;jobs&quot;, version: @ecto_job_version) end def down do EctoJob.Migrations.CreateJobTable.down(&quot;jobs&quot;) EctoJob.Migrations.Install.down() end end Upgrading to version 3.0 To upgrade your project to 3.0 version of ecto_job you must add a migration to update the pre-existent job queue tables: mix ecto.gen.migration update_job_queue defmodule MyApp.Repo.Migrations.UpdateJobQueue do use Ecto.Migration @ecto_job_version 3 def up do EctoJob.Migrations.UpdateJobTable.up(@ecto_job_version, &quot;jobs&quot;) end def down do EctoJob.Migrations.UpdateJobTable.down(@ecto_job_version, &quot;jobs&quot;) end end Add a module for the queue, mix in EctoJob.JobQueue. This will declare an Ecto.Schema to use with the table created in the migration, and a start_link function allowing the worker supervision tree to be started conveniently. defmodule MyApp.JobQueue do use EctoJob.JobQueue, table_name: &quot;jobs&quot; end Add perform/2 function to the job queue module, this is where jobs from the queue will be dispatched. defmodule MyApp.JobQueue do use EctoJob.JobQueue, table_name: &quot;jobs&quot; def perform(multi = %Ecto.Multi{}, job = %{}) do ... job logic here ... end end Add your new JobQueue module to the application supervision tree to run the worker supervisor: def start(_type, _args) do import Supervisor.Spec children = [ MyApp.Repo, {MyApp.JobQueue, repo: MyApp.Repo, max_demand: 100} ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) end If you want to run the workers on a separate node to the enqueuers, just leave your JobQueue module out of the supervision tree."},{"ref":"readme.html#usage","title":"EctoJob - Usage","type":"extras","doc":"Enqueueing jobs Jobs are Ecto schemas, with each queue backed by a different table. A job can be inserted into the Repo directly by constructing a job with the new/2 function: %{&quot;type&quot; =&gt; &quot;SendEmail&quot;, &quot;address&quot; =&gt; &quot;joe@gmail.com&quot;, &quot;body&quot; =&gt; &quot;Welcome!&quot;} |&gt; MyApp.JobQueue.new() |&gt; MyApp.Repo.insert() A job can be inserted with optional params: :schedule : runs the job at the given %DateTime{}. The default value is DateTime.utc_now(). :max_attempts : the maximum attempts for this job. The default value is 5. :priority (integer): lower numbers run first; default is 0 %{&quot;type&quot; =&gt; &quot;SendEmail&quot;, &quot;address&quot; =&gt; &quot;joe@gmail.com&quot;, &quot;body&quot; =&gt; &quot;Welcome!&quot;} |&gt; MyApp.JobQueue.new(max_attempts: 10) |&gt; MyApp.Repo.insert() %{&quot;type&quot; =&gt; &quot;SendEmail&quot;, &quot;address&quot; =&gt; &quot;mickel@gmail.com&quot;, &quot;body&quot; =&gt; &quot;Welcome!&quot;} |&gt; MyApp.JobQueue.new(priority: 1) |&gt; MyApp.Repo.insert() %{&quot;type&quot; =&gt; &quot;SendEmail&quot;, &quot;address&quot; =&gt; &quot;jonas@gmail.com&quot;, &quot;body&quot; =&gt; &quot;Welcome!&quot;} |&gt; MyApp.JobQueue.new(priority: 2, max_attempts: 2) |&gt; MyApp.Repo.insert() The primary benefit of EctoJob is the ability to enqueue and process jobs transactionally. To achieve this, a job can be added to an Ecto.Multi, along with other application updates, using the enqueue/3 function: Ecto.Multi.new() |&gt; Ecto.Multi.insert(:add_user, User.insert_changeset(%{name: &quot;Joe&quot;, email: &quot;joe@gmail.com&quot;})) |&gt; MyApp.JobQueue.enqueue(:email_job, %{&quot;type&quot; =&gt; &quot;SendEmail&quot;, &quot;address&quot; =&gt; &quot;joe@gmail.com&quot;, &quot;body&quot; =&gt; &quot;Welcome!&quot;}) |&gt; MyApp.Repo.transaction() Handling Jobs All jobs sent to a queue are eventually dispatched to the perform/2 function defined in the queue module. The first argument supplied is an Ecto.Multi which has been initialized with a delete operation, marking the job as complete. The Ecto.Multi struct must be passed to the Ecto.Repo.transaction function to complete the job, along with any other application updates. defmodule MyApp.JobQueue do use EctoJob.JobQueue, table_name: &quot;jobs&quot; def perform(multi = %Ecto.Multi{}, job = %{&quot;type&quot; =&gt; &quot;SendEmail&quot;, &quot;recipient&quot; =&gt; recipient, &quot;body&quot; =&gt; body}) do multi |&gt; Ecto.Multi.run(:send, fn _repo, _changes -&gt; EmailService.send(recipient, body) end) |&gt; Ecto.Multi.insert(:stats, %EmailSendStats{recipient: recipient}) |&gt; MyApp.Repo.transaction() end end When a queue handles multiple job types, it is useful to pattern match on the job and delegate to separate modules: defmodule MyApp.JobQueue do use EctoJob.JobQueue, table_name: &quot;jobs&quot; def perform(multi = %Ecto.Multi{}, job = %{&quot;type&quot; =&gt; &quot;SendEmail&quot;}), do: MyApp.SendEmail.perform(multi, job) def perform(multi = %Ecto.Multi{}, job = %{&quot;type&quot; =&gt; &quot;CustomerReport&quot;}), do: MyApp.CustomerReport.perform(multi, job) def perform(multi = %Ecto.Multi{}, job = %{&quot;type&quot; =&gt; &quot;SyncWithCRM&quot;}), do: MyApp.CRMSync.perform(multi, job) ... end Options You can customize how often the table is polled for scheduled jobs. The default is 60_000 ms. config :ecto_job, :poll_interval, 15_000 Control the time for which the job is reserved while waiting for a worker to pick it up, before the poller will make the job available again for dispatch by the producer. The default is 60_000 ms. config :ecto_job, :reservation_timeout, 15_000 Control the delay between retries following a job execution failure. Keep in mind, for jobs that are expected to retry quickly, any configured retry_timeout will only retry a job as quickly as the poll_interval. The default is 30_000 ms (30 seconds). config :ecto_job, :retry_timeout, 30_000 Control the timeout for job execution before an &quot;IN_PROGRESS&quot; job is assumed to have failed. Begins when job is picked up by worker. Similarly to retry_timeout, any configured execution_timeout will only retry a job as quickly as the poll_interval. The default is 300_000 ms (5 mins). config :ecto_job, :execution_timeout, 300_000 You can control whether logs are on or off and the log level. The default is true and :info. config :ecto_job, log: true, log_level: :debug See EctoJob.Config for configuration details."},{"ref":"readme.html#how-it-works","title":"EctoJob - How it works","type":"extras","doc":"Each job queue is represented as a PostgreSQL table and Ecto schema. Jobs are added to the queue by inserting into the table, using Ecto.Repo.transaction to transactionally enqueue jobs with other application updates. A GenStage producer responds to demand for jobs by efficiently pulling jobs from the queue in batches. When there is insufficient jobs in the queue, the demand for jobs is buffered. As jobs are inserted into the queue, pg_notify notifies the producer that new work is available, allowing the producer to dispatch jobs immediately if there is pending demand. A GenStageConsumerSupervisor subscribes to the producer, and spawns a new Task for each job. The callback for each job receives an Ecto.Multi structure, pre-populated with a delete command to remove the job from the queue. Application code then add additional commands to the Ecto.Multi and submit it to the Repo with a call to transaction, ensuring that application updates are performed atomically with the job removal. Scheduled jobs and Failed jobs are reactivated by polling the database once per minute."},{"ref":"readme.html#job-lifecycle","title":"EctoJob - Job Lifecycle","type":"extras","doc":"Jobs scheduled to run at a future time start in the &quot;SCHEDULED&quot; state. Scheduled jobs transition to &quot;AVAILABLE&quot; after the scheduled time has passed. Jobs that are intended to run immediately start in an &quot;AVAILABLE&quot; state. The producer will update a batch of jobs setting the state to &quot;RESERVED&quot;, with an expiry of 5 minutes unless otherwise configured. Once a consumer is given a job, it increments the attempt counter and updates the state to &quot;IN_PROGRESS&quot;, with an initial timeout configurable as execution_timeout, defaulting to 5 minutes. If the job is being retried, the expiry will be initial timeout * the attempt counter. If successful, the consumer can delete the job from the queue using the preloaded multi passed to the perform/2 job handler. If an exception is raised in the worker or a successful processing attempt fails to successfully commit the preloaded multi, the job is transitioned to the &quot;RETRY&quot; state, scheduled to run again after retry_timeout * attempt counter. If the processes is killed or is otherwise unable to transition to &quot;RETRY&quot;, it will remain in &quot;IN_PROGRESS&quot; until the execution_timeout expires. Jobs in the &quot;RESERVED&quot; or &quot;IN_PROGRESS&quot; state past the expiry time will be returned to the &quot;AVAILABLE&quot; state. Expired jobs in the &quot;IN_PROGRESS&quot; state with attempts &gt;= MAX_ATTEMPTS move to a &quot;FAILED&quot; state. Failed jobs are kept in the database so that application developers can handle the failure."},{"ref":"readme.html#job-timeouts-and-transactional-safety","title":"EctoJob - Job Timeouts and Transactional Safety","type":"extras","doc":"When performing long-running jobs or when configuring a short execution timeout, keep in mind that a job may be retried before it has finished and the retry has no proactive mechanism to cancel the running job. In the case that the initial job attempts to finish and commit a result, and the commit includes the preloaded multi passed as the first parameter to perform/2, the optimistic lock will fail the transaction. In the case where the job performs other side effects outside of the transaction such as calls to external APIs or additional database writes, these are suggested to implement other idempotency guarantees, as they will not be rolled back in a failed or duplicated job."}]